﻿/**
	RK enhanced eMail App via EWS Interface
**/

	
app.custom.formTasks.add('Incident', "Enhanced eMail App", function (formObj, viewModel) {   
	rk_EnhancedEmailApp ();
});

app.custom.formTasks.add('ServiceRequest', "Enhanced eMail App", function (formObj, viewModel) {   
	rk_EnhancedEmailApp ();
});

app.custom.formTasks.add('ChangeRequest', "Enhanced eMail App", function (formObj, viewModel) {   
	rk_EnhancedEmailApp ();	
});

app.custom.formTasks.add('Incident', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
	var vm = pageForm.viewModel;		
		//If the user is not an analyst, hide the task
		if (!session.user.Analyst) { 
			$( ".taskmenu li:contains('Enhanced eMail App')" ).hide() 
		} 
	});
	return;
});

app.custom.formTasks.add('ServiceRequest', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
	var vm = pageForm.viewModel;		
		//If the user is not an analyst, hide the task
		if (!session.user.Analyst) { 
			$( ".taskmenu li:contains('Enhanced eMail App')" ).hide() 
		} 
	});
	return;
});

app.custom.formTasks.add('ChangeRequest', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
	var vm = pageForm.viewModel;		
		//If the user is not an analyst, hide the task
		if (!session.user.Analyst) { 
			$( ".taskmenu li:contains('Enhanced eMail App')" ).hide() 
		} 
	});
	return;
});

function rk_EnhancedEmailApp ()
{
    console.log ("started");
    var vm = pageForm;
	window.tmpl="#: data.Name # (#: data.Email #)";
		
	require(["text!/CustomSpace/RKSendEmail/RKSendEmail.html"], function (tpl) {

		//build the template for the window new approach for localization support :-)		
		var properties = {
                Target: "RKeMailApp"
            };
		
		var built = _.template(tpl);			
        var rkview = new kendo.View(built(properties), { wrap: false });

        //add in hidden window			
        rkview.render();
        rkview.destroy();//there is some issue with the cloned element if we don't destroy the view
		
		var attachedFiles= {attachedFiles: [], uploadedFiles: [], currentFile: 0, guid: ""};		
		win=null;
		upload=null;
		
		var cont = rkview.element; //we have the element in memory so no need use a selector		
		
		win = cont.kendoCiresonWindow({
			title: localization.RKeMailApp,
			width: 1024,
			height: 700,                        
			actions: ["Close"],
			attachedFiles: attachedFiles,
			
			deactivate: function() 
			{
				//console.log ("window closed"); 			
				// reset file upload widget - no other possibility available...
				// important --> dialog MUST be destroyed !
			    
				$('.k-upload').remove();
				$('#myWrapper').append( "<input name='files' id='files' type='file' />" );
				
				// important --> dialog MUST be destroyed otherwise the widgets not working correctly 2nd time!
			    this.destroy(); 
				
				},
			
			activate: function () {
				getAffectedUserEmail(_vmWindow);
				
				
				setTimeout(function () {
					$('#mailToDropDown').each(function(){							
						$(this).data('kendoComboBox').setOptions({template: "#: data.Name # (#: data.Email #)"});
					});
				
					$('#mailCCDropDown').each(function(){							
						$(this).data('kendoComboBox').setOptions({template: "#: data.Name # (#: data.Email #)"});
					});					
				}, 500);
								
				var upload=$("#files").kendoUpload({		
					multiple: true,	
					showFileList: true,
					async: {
						saveUrl: "save",
						removeUrl: "remove",
						autoUpload: false
					},
					
					template: "<div style='height: 32px; width: 75%; float: left;'>"+localization.RKeMailFileName+": #=name# | "+localization.RKeMailFileSize+": #=(size/1024/1024).toFixed(2) # | "+localization.RKeMailFileExtension+": #=files[0].extension#</div> <div style='height: 32px; width: 24%; float: right;'><button class='k-button k-upload-action' aria-label='Remove' type='button'><span title='Remove' class='fa fa-crosshairs k-icon k-i-close k-i-x'></span></button></div><div style='float:none'></div>",
					
					// for future use...
					//localization: {
					//	select: <%= localization.Attachments %>,
					//	remove: "customRemove",
					//	},
						
					remove: function removeFile (e)	{
						attachedFilesArray=win.attachedFiles.attachedFiles;
						var FilesIdx = attachedFilesArray.indexOf(e.files[0]);
						attachedFilesArray=attachedFilesArray.splice(FilesIdx,1);
						// e.preventDefault();
						// e.stopPropagation();
					},	
					
					select: function selectFile(e) {												
							
							for(var idx = 0; idx < this.element[0].files.length; idx++)
							{
								win.attachedFiles.attachedFiles.push(this.element[0].files[idx])																					
							};
							
							// hide upload button !
							setTimeout(function () {
								$(".k-upload-selected").css('display', 'none');
								}, 500);											
							
							// add "remove" icons to each line ... 
							setTimeout(function () {
								$(".k-icon").css('display', 'inline-block');
								}, 500);
					},								
				});
				
				$("#files").parent().css({width:160});
				
				// hide upload button after dropping content in the dropzone
				$(".k-dropzone").on("drop", function (e) {								
					e.preventDefault();
					e.stopPropagation();
					var files = e.originalEvent.dataTransfer.files;																
					for(var idx = 0; idx < files.length; idx++)
							{
								win.attachedFiles.attachedFiles.push(files[idx])																					
							};																
					});
			}
		}).data("kendoWindow");
						
		win.attachedFiles=attachedFiles;
		
		//this view Model is bound to the window element
		var _vmWindow = new kendo.observable({
			emailTo: "",
			emailCC: "",
			emailSubject: "[" + vm.viewModel.Id + "] " + vm.viewModel.Title,
			emailHTMLMessage: "",
			emailTextMessage:"",
			emailAttachment: "",
			emailTemplateDataSource: tempateDataSource,
			emailTemplateValue: "",
			attachmentErrorMessage: "",
			addToLog: true,
			okEnabled: true,
			okClick: function () {

				this.emailTo = $("#emailTo").val();
				//validate email addresses first
				if ((this.emailTo == null || this.emailTo == "") &&
					(this.emailCC == null || this.emailCC == "")) {
					kendo.ui.ExtAlertDialog.show({
						title: localization.InvalidEmailAddress,
						message: localization.PleaseProvideEmailAddress
					});
					return;
				}
				else {
					var arrEmail = _.union(this.emailTo.split(";"), this.emailCC.split(";"));
					var invalidEmailAdress = validateEmailAddress(arrEmail);
					if (invalidEmailAdress != null) {
						kendo.ui.ExtAlertDialog.show({
							title: localization.InvalidEmailAddress,
							message: localization.InvalidEmailAddressMessage.replace("{0}", invalidEmailAdress)
						});
						return;
					}
				}

				//if we are adding to action log we require there to be message content
				if (this.addToLog) {
					var editor = cont.find("#rkMessageEditor").data("kendoEditor");
					this.set("emailTextMessage", editor.body.innerText || editor.body.textContent);

					var trimmedMessage = (this.emailTextMessage && _.isString(this.emailTextMessage)) ? this.emailTextMessage.trim() : "";

					if (trimmedMessage.length <= 0) {
						kendo.ui.ExtAlertDialog.show({
							title: localization.MessageRequired,
							message: localization.MessageRequiredWhenAddingLogEntry
						});
						return;
					}
				}

				//send email
				kendo.ui.progress($(".k-window"), true);
				sendEmail(this, attachedFiles);

			},
			cancelClick: function () {
				win.close();
			},
			
			selectFromAddressBook: function (e) {
			},
			
			userDataSource : new kendo.data.DataSource ({
				serverFiltering: true,
				transport: {
					read: {
						url: function (data) {										
							var userItem = (data.filter.filters.length > 0) ? data.filter.filters[0].value : "%";   								
							return "/api/V3/User/GetUserList?userFilter="+ userItem + "&filterByAnalyst=false&groupsOnly=false&maxNumberOfResults=50&fetchAll=false";										
						},
						dataType: "json"
					}
				}
			}),
			
			onUserItemChange: function (e) {
				var curitem = e.sender.dataItem(e.sender.select());     
				this.selectedUserItemName = curitem.Name;
				var dataItem = e.sender.dataItem(e.sender.selectedIndex);
				if (!_.isUndefined(dataItem))
					this.selectedUserItemId = dataItem.Id;
					this.selectedUserItemEmail=dataItem.Email;
			},
			
			addToUserItem: function (e) {
				if (!_.isUndefined(this.selectedUserItemId)) { 
					var curSel=_vmWindow.get("emailTo");
					if (curSel !="") 
					{
						_vmWindow.set("emailTo", curSel+";"+this.selectedUserItemEmail);							
					}
					else
					{
						_vmWindow.set("emailTo",this.selectedUserItemEmail);							
					}
				}
			},
			
			onCCUserItemChange: function (e) {
				var curitem = e.sender.dataItem(e.sender.select());     
				this.selectedCCUserItemName = curitem.Name;
				var dataItem = e.sender.dataItem(e.sender.selectedIndex);
				if (!_.isUndefined(dataItem))
					this.selectedCCUserItemId = dataItem.Id;
					this.selectedCCUserItemEmail=dataItem.Email;
			},
			
			addCCToUserItem: function (e) {
				if (!_.isUndefined(this.selectedCCUserItemId)) { 
					var curSel=_vmWindow.get("emailCC");
					if (curSel !="") 
					{
						_vmWindow.set("emailCC", curSel+";"+this.selectedCCUserItemEmail);							
					}
					else
					{
						_vmWindow.set("emailCC",this.selectedCCUserItemEmail);							
					}
				}
			},
			
			emailTemplateChange: function (e) {
				var filter = {
					field: "Id",
					operator: "eq",
					value: e.sender._old //_old stores the selected value's id
				};
				tempateDataSource.filter(filter);
			
				var dView = tempateDataSource.view();
				var subject = (dView.length > 0) ? "[" + vm.viewModel.Id + "] " + dView[0].Subject : "[" + vm.viewModel.Id + "] " + vm.viewModel.Title;
				var content = (dView.length > 0) ? dView[0].Content : "";
				
				content = cont.find("#rkMessageEditor").html(content).text();

				//change new line (\n) to line break (<br>) on non-html template only
				if (!content.match(/<(\w+)((?:\s+\w+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)>/)) {
					content = cont.find("#rkMessageEditor").html(content).text().replace(/\r\n|\r|\n/g, "<br />");
				}
				
				this.set("emailSubject", subject);
				this.set("emailHTMLMessage", content);

				tempateDataSource.filter({});
			},
			showChangeStatus: (vm.type === "Incident"),
			changeStatus: false,
			sendEmailAttachment: null,
			setFirstResponseDate: (_.isNull(vm.viewModel.FirstResponseDate)) ? true : false,
			enableFirstResponseDate: (_.isNull(vm.viewModel.FirstResponseDate)) ? true : false,													
		});
					   
		//add control to the window
		kendo.bind(cont, _vmWindow);
		
		//init editor
		buildEditor(cont.find("#rkMessageEditor"), _vmWindow);

		cont.removeClass('hide');					
		cont.show();
		win.open();		
		
		// init signature
		soapPacketSignature=initSoapMessageGetSignature();
		sendSoapPacketSignature (soapPacketSignature, _vmWindow,true)	
		
	}); // require		

    //more functions
	var tempateDataSource = new kendo.data.DataSource({
		transport: {
			read: "/EmailNotification/GetNotificationTemplates",
			dataType: "json"
		},
		schema: {
			model: {
				fields: {
					Id: { type: "string" },
					Name: { type: "string" }
				}
			}
		}
	});

	var addToCommentLog = function (commentMessage) {
		var newActionLog = {
			EnteredBy: session.user.Name,
			Title: localization.EMailSent,
			IsPrivate: false,
			EnteredDate: new Date().toISOString(),
			LastModified: new Date().toISOString(),
			Description: commentMessage,
			DescriptionDisplay: commentMessage,
			Image: app.config.iconPath + app.config.icons["E-Mail Sent"], 
			ActionType: {
				Id: "15e86d4a-1b55-01be-C9fa-660a3cb3fc26",
				Name: "Email Sent"
			}
			//ActionType: { Id: "15E86D4A-1B55-01BE-C9FA-660A3CB3FC26", Name: "E-Mail Sent" }
		}
		if (!vm.viewModel.ActionLog) {
			vm.viewModel.ActionLog = [];
		}
		
		var actionLogType = app.controls.getWorkItemLogType(vm.viewModel);
		if (actionLogType) {
			vm.viewModel[actionLogType].push(newActionLog);
		}
	}

            var saveFailure = function (exceptionMessage) {
                if (exceptionMessage == localization.RequiredFieldsErrorMessage) {
                    app.lib.message.add(exceptionMessage, "danger");
                } else {
                    //fallback to generic message
                    app.lib.message.add(localization.PleaseCorrectErrors, "danger");
                }
                app.lib.message.show();
            }

            var getAffectedUserEmail = function (_vmWindow) {
                var affectedUserId = (vm.viewModel.RequestedWorkItem) ? vm.viewModel.RequestedWorkItem.BaseId : "";
                $.ajax({
                    url: "/EmailNotification/GetffectedUserEmail",
                    type: "GET",
                    data: { baseId: affectedUserId },
                    success: function (data, textStatus, jqXHR) {
                        _vmWindow.set("emailTo", data);
                    }
                }); 
            }

            var validateEmailAddress = function (arrEmail) {
                var invalidEmailAddress = null;
                for (var i in arrEmail) {
                    var email = arrEmail[i].trim();
                    if (email == "") continue;
                    if (app.validateEmail(email) == false) {
                        invalidEmailAddress = email;
                        break;
                    }
                }
                return invalidEmailAddress;
            }
			
			function files2Base64(Attachments, tmpl)
			{						
				var promises = [];						
				for (var i = 0; i < Attachments.length; i++) {
					files2Base64SingleFile(Attachments[i], tmpl , promises);				
				}				
				return $.when.apply($, promises);	
			}
			
			function files2Base64SingleFile(file, tmpl, promises)
			{
				var reader = new FileReader(),
				d = new $.Deferred();

				promises.push(d);
				// Make sure we "capture" the correct 'd'
				
				(function(d){
					reader.onload = function (evt)
					{
						xx = evt.target.result.split(",");						
						console.log (evt);				
						tmpl.push("<t:FileAttachment>" +
										"<t:Name>"+file.name+"</t:Name>" +
										"<t:Content>"+ xx[1] + "</t:Content>" +
									"</t:FileAttachment>")
						console.log ('4 ' + tmpl);
						d.resolve(evt, tmpl);
					}
				}(d));
				
				reader.readAsDataURL(file);

				return $.when.apply($, promises);				
			}
			
			var initInlineMessageAttachments = function (inlineAttachments)
			{
			
				var m,
					urls = [], 				
					rex = /<img\s[^>]*?src\s*=\s*['\"]([^'\"]*?)['\"][^>]*?>/g;

				while ( m = rex.exec( inlineAttachments ) ) {
					urls.push( m[1] );
				}

				var rx = /<img[^>]*>/g;
				var idx=0;
				inlineAttachments=inlineAttachments.replace(rx,function($0,$1)
				{					
					idx++;
					
					// keeps formatting of size :-)
					wi=$($0)[0].attributes['width'];
					he=$($0)[0].attributes['height'];
					wiTag="";
					heTag="";
					
					if (typeof wi != 'undefined')
					{
					  wiTag="width="+wi.value;
					}
					
					if (typeof he != 'undefined')
					{
					  heTag="width="+he.value;
					}
					
					var retval ="<img id='" + idx + "' src='cid:image" + idx + ".png'" + wiTag + " " + heTag + " >";
					return retval;					
					//return params[$1];
				});
           
				var tmpl="";
				var xx ;
		        for (let i = 0; i < urls.length; i++) {				  
					xx = urls[i].split(",");
					tmpl = tmpl+"<t:FileAttachment>" +
									"<t:Name>image"+(i+1)+".png</t:Name>" +							
									"<t:ContentId>image"+(i+1)+".png</t:ContentId>"+			
									"<t:IsInline>true</t:IsInline>" +	
									"<t:IsContactPhoto>false</t:IsContactPhoto>"+
									"<t:Content>"+ xx[1] + "</t:Content>" +
								"</t:FileAttachment>"
				}				
				return [tmpl, inlineAttachments];	
			}
			
			var initMessageRecipients = function (emailToRecipients)
			{
				var recipientList = ""				
				var recipientArray =emailToRecipients.split(";");				
				for (let i = 0; i < recipientArray.length; i++) {				  
				  recipientList=recipientList +"<t:Mailbox> <t:EmailAddress>" + recipientArray[i] + "</t:EmailAddress></t:Mailbox>";
				}
				return recipientList;
			}

			
			var initSoapMessageGetSignature = function ()
			{			
				var soapPacket =  "<?xml version='1.0' encoding='utf-8'?>" +
					"<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/' xmlns:m='http://schemas.microsoft.com/exchange/services/2006/messages' xmlns:t='http://schemas.microsoft.com/exchange/services/2006/types'>" +
						"<soap:Header>" +
							"<t:RequestServerVersion Version='Exchange2010_SP2' />" +
						"</soap:Header>" +
							"<soap:Body>" +
								"<m:GetUserConfiguration>" +
									"<m:UserConfigurationName Name='OWA.UserOptions'>" +
										"<t:DistinguishedFolderId Id='root' />" +
									"</m:UserConfigurationName>" +
									"<m:UserConfigurationProperties>All</m:UserConfigurationProperties>" +
								"</m:GetUserConfiguration>" +
							"</soap:Body>" +
					"</soap:Envelope>"	
				return soapPacket;				
			}
			
			
			var initSoapMessage = function (emailSubject, emailToRecipients, emailCCRecipients, emailBody, emailAttachments )
			{
				var soapPacket = "<?xml version='1.0' encoding='utf-8'?>" +
					"<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/' xmlns:m='http://schemas.microsoft.com/exchange/services/2006/messages' xmlns:t='http://schemas.microsoft.com/exchange/services/2006/types'>" +
						"<soap:Header>"+
							"<t:RequestServerVersion Version='Exchange2010_SP2' />"+
						"</soap:Header>"+
						"<soap:Body>" +
							"<m:CreateItem MessageDisposition='SendAndSaveCopy'>"+		
							  "<m:SavedItemFolderId> <t:DistinguishedFolderId Id='sentitems' /></m:SavedItemFolderId>" +
								"<m:Items>" +
									"<t:Message>" +
										"<t:Subject>" + emailSubject + "</t:Subject>" + 
										"<t:Body BodyType='HTML'>" + emailBody + "</t:Body>" 


										if (emailAttachments != "")
											{
												soapPacket=soapPacket + "<t:Attachments>" + emailAttachments + "</t:Attachments>"  
											}
										
										soapPacket=soapPacket + 
										
										"<t:ToRecipients>" + emailToRecipients + "</t:ToRecipients>"
					
										if (emailCCRecipients != "")
										{
											soapPacket=soapPacket + "<t:CcRecipients>" + emailCCRecipients + "</t:CcRecipients>" 
										}
					
										soapPacket=soapPacket + 
									"</t:Message>" +
								"</m:Items>" +
							"</m:CreateItem>" +
						"</soap:Body>" +
					"</soap:Envelope>"
				return soapPacket;
			}
			
			
			var sendSoapPacketSignature = function (soapPacket, _vmWindow, initCall)
			{				
				var request = new XMLHttpRequest();				
				request.open("POST", "https://w2012r2mxs.roki.loc/EWS/Exchange.asmx", true);
				request.setRequestHeader("Content-type", "text/xml; charset=utf-8");
				request.setRequestHeader('Access-Control-Allow-Origin', '*');
				request.setRequestHeader("Access-Control-Allow-Headers", "Content-type");
				request.setRequestHeader("Access-Control-Allow-Methods", "POST");
				request.withCredentials = true;    

				request.onreadystatechange = function(e)
					{
						if (request.readyState == 4 && request.status == 200)
						{							
							var xml = request.response;
							var xmlDoc = $.parseXML( xml );
							var $xml = $( xmlDoc );
							var dictionary = $xml.find('t\\:DictionaryEntry');
							var userConfigurationDictionary = {};
							dictionary.each(function()
							{
								key=$(this).find("t\\:DictionaryKey")[0].childNodes[1].textContent;
								console.log (key);
								node=$(this).find("t\\:DictionaryValue");
								if ($(this).find("t\\:DictionaryValue")[0].childNodes.length !=0)
								{								
									value=$(this).find("t\\:DictionaryValue")[0].childNodes[1].textContent;
								}
								else
								{
									value="";
								}
								userConfigurationDictionary[key]=value;								
							});
							
							var editor = $("#rkMessageEditor").data("kendoEditor");
 				
				
							if (((userConfigurationDictionary["autoaddsignature"]=="true") && (initCall == true)) || (initCall == false))
							{							
								htmlObject=$("<div><p> </p><p> </p><p> </p> "+userConfigurationDictionary["signaturehtml"]+"</div>");
								htmlObject.find("img").each(function()
								{
									img=$(this)[0].nextSibling.innerText;
									$(this)[0].parentNode.removeChild($(this)[0].nextSibling)
									// $(this)[0].outerHTML="<img src='"+$(this)[0].nextSibling.outerText+"'//>";
									$(this)[0].outerHTML="<img src='"+img+"'//>";
																
								});
															
								editor.exec("inserthtml", { value: htmlObject[0].outerHTML });

								var range = editor.getRange();
								  if (range.collapsed) {
									var textNode = editor.body.firstChild;
									range.setStart(textNode, 0);
									range.collapse(true); // collapse to start
									editor.selectRange(range);
								  }
							}
						}
						
						if (request.readyState == 4 && request.status == 401)
						{							
							alert ("get OWA Signature not successful ! - Error 4xx");
							kendo.ui.progress($(".k-window"), false);                        
                            // win.close();
						}

						if (request.readyState == 4 && request.status == 500)
						{						
							alert ("get OWA Signature not successful ! - Error 5xx");
							kendo.ui.progress($(".k-window"), false);                        
                            // win.close();
						}
					};

				request.send(soapPacket);			
			}
				
			var sendSoapPacket = function (soapPacket, _vmWindow)
			{
				var bChangeStatus = _vmWindow.changeStatus;
                var bAddActionLog = _vmWindow.addToLog;
				var bSetFirstResponsDate = _vmWindow.setFirstResponseDate;
				var strMessagePlain = _vmWindow.emailTextMessage;	
				var addToLogSkipped = false;	
				var bHasAttachment = (_vmWindow.emailAttachment != "");				
				var request = new XMLHttpRequest();				
				
				request.open("POST", "https://w2012r2mxs.roki.loc/EWS/Exchange.asmx", true);				
				request.setRequestHeader("Content-type", "text/xml; charset=utf-8");
				request.setRequestHeader('Access-Control-Allow-Origin', '*');
				request.setRequestHeader("Access-Control-Allow-Headers", "Content-type");
				request.setRequestHeader("Access-Control-Allow-Methods", "POST");
				request.withCredentials = true;    

				request.onreadystatechange = function(e)
					{
						if (request.readyState == 4 && request.status == 200)
						{
							kendo.ui.progress($(".k-window"), false);  
							if (bChangeStatus) {
								vm.viewModel.Status.set("Id", app.constants.workItemStatuses.Incident.Pending);
								vm.viewModel.Status.set("Name", localization.Pending);
							}
							
							if (bAddActionLog) {
								strMessagePlain = _.isUndefined(strMessagePlain) ? "" : strMessagePlain.substring(0, 4000);

								if (strMessagePlain.length > 0) {
									addToCommentLog(strMessagePlain.replace(/</g, '&lt;').replace(/>/g, '&gt;'));
								} else {
									bAddActionLog = false;
									addToLogSkipped = true;
								}
							}

							if (bSetFirstResponsDate) {
								vm.viewModel.set("FirstResponseDate", new Date().toISOString());
							}
                            win.close();
							
							//save changes and show warnings, if any
                                var handleSaveSuccess = function () {
                                    if (bAddActionLog || bHasAttachment || bChangeStatus || bSetFirstResponsDate) {
                                        vm.save(function () {
                                            app.lib.message.add(localization.ChangesApplied, "success");
                                            switch (vm.type) {
                                                case "ChangeRequest":
                                                    location.href = "/ChangeRequest/Edit/" + vm.viewModel.Id + "/";
                                                    break;
                                                case "ServiceRequest":
                                                    location.href = "/ServiceRequest/Edit/" + vm.viewModel.Id + "/";
                                                    break;
                                                case "Incident":
                                                    location.href = "/Incident/Edit/" + vm.viewModel.Id + "/";
                                                    break;
                                                case "Problem":
                                                    location.href = "/Problem/Edit/" + vm.viewModel.Id + "/";
                                                    break;
                                                case "ReleaseRecord":
                                                    location.href = "/ReleaseRecord/Edit/" + vm.viewModel.Id + "/";
                                                    break;
                                                default:
                                                    //my workitem view
                                                    location.href = "/View/cca5abda-6803-4833-accd-d59a43e2d2cf/";
                                                    break;
                                            }
                                        }, saveFailure);
                                    }
                                }
                                if (addToLogSkipped) {
                                    //note: addToLogSkipped dialog will only show if the empty message validation fails
                                    $.when(kendo.ui.ExtAlertDialog.show({
                                        title: localization.SkippedAddingLogEntryTitle,
                                        message: localization.ErrorAddingLogEntryMessage,
                                        icon: "fa fa-warning"
                                    })).done(function() {
                                        handleSaveSuccess();
                                    });
                                } else {
                                    handleSaveSuccess();
                                }
						}
						
						if (request.readyState == 4 && request.status == 401)
						{							
							alert ("Send Mail not successful ! - Error 4xx");
							kendo.ui.progress($(".k-window"), false);                        
                            // win.close();
						}

						if (request.readyState == 4 && request.status == 500)
						{						
							alert ("Send Mail not successful ! - Error 5xx");
							kendo.ui.progress($(".k-window"), false);                        
                            // win.close();
						}
					};

				request.send(soapPacket);			
			}
			
			var sendEmail = function (_vmWindow, attachedFiles)
			{				
				window.rktmpl=[];
				tmpl= window.rktmpl;
				var toRecipients=initMessageRecipients (_vmWindow.emailTo);
				var ccRecipients=""
				
				if (_vmWindow.emailCC !="")
				{
					ccRecipients=initMessageRecipients (_vmWindow.emailCC);
				}
				
				var subject=_vmWindow.emailSubject.replace(/</g, "%3C").replace(/>/g, "%3E");				
				var body = _vmWindow.emailHTMLMessage;		

				var editor = $("#rkMessageEditor").data("kendoEditor");
				var html = editor.selectedHtml();
				
				var inlineAttachments=initInlineMessageAttachments (_vmWindow.emailHTMLMessage);				
				var decoded = ($('<div/>').html(inlineAttachments[1]))[0].innerHTML				
				var htmlbody="<html><head></head><body>"+decoded+"</body></html>"  

				// replacement of certain characters in the mail  body
				htmlbody = htmlbody.replace(/\</g,"&lt;")   //for <
				htmlbody = htmlbody.replace(/\>/g,"&gt;")   //for >
				htmlbody=htmlbody.replace("&nbsp;"," ")       // is inserted by kendo after paste of images ?!?
				htmlbody=htmlbody.replace(/&nbsp;/g, ' ');
								
				var soapPacket="";
				var otherFiles ="";
				if (attachedFiles.attachedFiles.length>0)
				{
					files2Base64(attachedFiles.attachedFiles, tmpl).done(function(data,otherFiles){
						console.log ("callback");											
						soapPacket=initSoapMessage( subject , toRecipients , ccRecipients , htmlbody , inlineAttachments[0]+otherFiles);
						sendSoapPacket (soapPacket, _vmWindow);						
					});
				}

				else
				{
					soapPacket=initSoapMessage( subject , toRecipients , ccRecipients , htmlbody , inlineAttachments[0]);
					sendSoapPacket (soapPacket, _vmWindow)					
				}
			};

            var buildEditor = function (targetEle, vm) {
                var defaultTools = [
                     "bold", "italic", "underline",
                     "formatting", "foreColor", "backColor",
                     "justifyLeft", "justifyCenter", "justifyRight", "justifyFull",
                     "insertUnorderedList", "insertOrderedList", "indent", "outdent",
                     "createLink", "unlink", "insertImage",
                     "viewHtml",					 
                     "createTable", "addColumnLeft", "addColumnRight", "addRowAbove", "addRowBelow", "deleteRow", "deleteColumn",		
					{
					name: "addSignature",			
					tooltip: localization.RKeMailAddSignature,						
					exec: function(e) {												
						soapPacketSignature=initSoapMessageGetSignature();
						sendSoapPacketSignature (soapPacketSignature, vm, false)			
						//e.preventDefault();							
					},
					},
                     { name: "insertLineBreak", shift: true },
                     { name: "insertParagraph", shift: true }
                ];
                var mobileTools = [
                    "formatting",
                    "createLink", "unlink", "insertImage", "viewHtml",
                    "bold", "italic", "underline",
                    "insertUnorderedList", "insertOrderedList", "indent", "outdent",
                    "createTable", "addColumnLeft", "addColumnRight", "addRowAbove", "addRowBelow", "deleteRow", "deleteColumn",
                    { name: "insertLineBreak", shift: true },
                    { name: "insertParagraph", shift: true }
                ];
                var editor = targetEle.data("kendoEditor");
                if (!_.isUndefined(editor)) { return;}
                editor = targetEle.kendoEditor({
                    change: function (e) {
                        var content = e.sender.body.innerText || e.sender.body.textContent;
                        vm.set("emailTextMessage", content);
                    },
                    tools: app.isMobileDevice() ? mobileTools : defaultTools,
                    stylesheets: ["/Content/Styles/cireson.mentions-in-keditor.min.css"],
                    encoded: false,
                    paste: function(e) {
                        //added to fix BUG2808. On Chrome, when doing a copy-paste of content to kendo editor, the editor wraps line-breaks with <div clas="k-paste-container"/>. 
                        //Removed the added class so newlines/line breaks will properly render on Chrome.
                        e.html = e.html.replace(/k-paste-container/g, "");
                    },
					fileBrowser: {}

                });

                $.get("/api/V3/User/GetUserList", { fetchAll: true }, function (data) {

                    var names = $.map(data, function (value, i) {
                        return { 'id': i, 'name': value.Name, 'guid': value.Id, 'email': value.Email };
                    });

                    var at_config = {
                        at: "@",
                        data: names,
                        headerTpl: '<div class="atwho-header">Search Users</div>',
                        insertTpl: '${atwho-at}${name}',
                        displayTpl: "<li id='${guid}'> ${name} <br><span>${email}</span> </li>",
                        limit: 5,
                        startWithSpace: false,
                        editableAtwhoQueryAttrs: {}
                    }

                    var iframe = editor.prev()[0];
                    var innerDoc = iframe.contentDocument || iframe.contentWindow.document;
                   
                    $inputor = $(innerDoc).find('body').atwho(at_config);
                    $inputor.caret('pos', 47);
                    $inputor.atwho('run');

                    $inputor.on("inserted.atwho", function (event, $li) {
                        var toField = $("#emailTo").val();
                        if (toField.lastIndexOf(";") != toField.length - 1)
                            toField += ';';
                        var userId = $($li)[0].id;

                        var user = _.filter(data,
                            function (el) {
                                return el.Id === userId;
                            });

                        user = user[0];

                        if (toField.indexOf(user.Email) === -1) {
                            var emailTo = toField + user.Email + ';';
                            $("#emailTo").val(emailTo);
                        }

                    });

                    $(document).on("removed.atwho", function (e) {
                        var toField = $("#emailTo").val();
                        if ($(iframe).is($(e.target.activeElement)) && $inputor.text().indexOf(e.removedAtWhoName) == -1) {
                            var userId = e.removedAtWhoId;

                            var user = _.filter(data,
                                function (el) {
                                    return el.Id === userId;
                                });

                            user = user[0];

                            if (toField.indexOf(user.Email + ';') > -1) {
                                var emailTo = toField.replace(user.Email + ';', '');
                                $("#emailTo").val(emailTo);
                            } else if (toField.indexOf(user.Email) > -1) {
                                var emailTo = toField.replace(user.Email, '');
                                $("#emailTo").val(emailTo);
                            }
                        }
                    });
                });
            }

}; // function    

